#-*- coding:Utf-8 -*-

import pygtk
pygtk.require('2.0')
import gtk
import hildon
import MySQLdb as mdb
import datetime
import os
import re
import gobject

Currency = "" #Here you can specify what currency you would like to use

Date = ['empty','empty','empty','empty']
CurrentCurrency = ['empty']
SelectedItem = ['empty']
SelectedTag = ['empty']
Month = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
Day = [' 1', ' 2', ' 3', ' 4', ' 5', ' 6', ' 7', ' 8', ' 9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31']
DayName = ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday']
Year = ['2015', '2016', '2017', '2018', '2019', '2020', '2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028', '2029', '2030', '2031', '2032', '2033', '2034', '2035', '2036', '2037', '2038', '2039', '2040', '2041', '2042', '2043', '2044', '2045']
Items = []
CurrentItem = []
CurrentExpenses = []
CurrentIncomes = []
CurrentExpensesAll = []

def main():
    program = hildon.Program.get_instance()

win = hildon.StackableWindow()
win.set_title("Track Your Expenses")
table = gtk.Table(10, 15, True)
menu = hildon.AppMenu()
win.add(table)

win_details = hildon.StackableWindow()    #We must define the window that contains the details here to be able to refresh the pannable areas correctly (i.e. we cannot define "delete_detail" inside "current_month" because of the "return table" expression; it would mess up the pannable areas when they are refreshed)

current_date = datetime.datetime.now()
current_month_name = current_date.strftime("%B")
current_year = current_date.strftime("%Y")
previous_month = Month[(datetime.datetime.today().month -1)-1]

con = mdb.connect('localhost', 'user', 'me', 'Expense');
cur = con.cursor()

def button_press(widget, event):                                                       #This function is for 
    if event.type == gtk.gdk.BUTTON_PRESS:                                      #gtk.MenuItem to 
        widget.popup(None, None, None, event.button, event.time) #show when you 
        return True                                                                                    #click the button
    return False

def edit_detail(data):                       #This function is for the "Edit" menuitem which i 
    win = hildon.StackableWindow() #thought to be useful but i'm not sure about it for
    win.set_title("Edit Detail")              #now so i don't add it to the gtk.Menu
    appmenu = hildon.AppMenu()
    appmenu.show_all()
    table = gtk.Table(4, 1, True)
    win.add(table)

    win.set_app_menu(appmenu)
    win.show_all()
#Here we print the current month's little summarized statistics to the main window
def current_month(): 
    Item = []
    currency = []
    cur.execute("select Item, Ft from Expenses where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
    row_count = cur.rowcount
    table = gtk.Table (row_count, 1, False)
    table.set_row_spacings(20)
#Here we count the rows of the datas of the current month of the current year, and append Item and Ft values to the lists
    for i in range(1):
        for j in range(row_count):
            row = cur.fetchone()
            Item.append(row[0])
            currency.append(row[1])
#Here we summarize total incomes for the current month of the current year
    cur.execute("select Ft from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
    row_count = cur.rowcount
    for j in range(row_count):
        row = cur.fetchone()
        CurrentIncomes.append(row[0])

#Here we summarize total expenses for the current month of the current year
    cur.execute("select Ft from Expenses where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
    row_count = cur.rowcount
    for j in range(row_count):
        row = cur.fetchone()
        CurrentExpensesAll.append(row[0])

#Here we separate Item and Ft values and connect them to each other then summarize Ft
    for i in range(len(Item)):
        c = []
        for j in range(len(Item)):
            if Item[i] == Item[j]:
                c.append(currency[j])
        CurrentExpenses.append(sum(c))
#Here we define the detailed expenses of each and every summarized expense
    def detailed_item(k, l):
        #win_details = hildon.StackableWindow()
        win_details.set_title(l)
        menu = hildon.AppMenu()
        table_details = gtk.Table(1, 1, False)
        table_details.set_row_spacings(40)
        pannable_area_details = hildon.PannableArea()

        def details():
            cur.execute("select * from Expenses where Item = '"+l+"' and Month = '"+current_month_name+"';")
            current_expense = cur.rowcount
            table_current_expense = gtk.Table(current_expense, 1, False)

            for j in range(1):
                for k in range(current_expense):
                    row = cur.fetchone()
                    menu = gtk.Menu()
                    hbox = gtk.HBox(False, 0)
                    menu.set_size_request(90, 90)
                    lb = gtk.Label()
                    hbox.pack_start(lb, False, False, 0)
                    label_edit = gtk.Label()
                    label_delete = gtk.Label()
                    #label_edit.set_text("<span size='20000'>Edit</span>")
                    label_delete.set_text("<span size='20000'>\nDelete</span>")
                    #label_edit.set_use_markup(True)
                    label_delete.set_use_markup(True)
                    #label_edit.show()
                    label_delete.show()
                    #menuitem_edit = gtk.MenuItem()
                    menuitem_delete = gtk.MenuItem()
                    #menuitem_edit.add(label_edit)
                    menuitem_delete.add(label_delete)
                    #menuitem_edit.show()
                    menuitem_delete.show()
                    #menuitem_edit.connect("activate", edit_detail)
                    menuitem_delete.connect("activate", lambda k=k, row=row: delete_detail(k, row))
                    #menu.append(menuitem_edit)
                    menu.append(menuitem_delete)
                    label_current_expense = gtk.Label(str(row[1])+" | "+str(row[3])+" | "+str(row[5])+" "+Currency+" | "+str(row[7]))
                    button_current_expense = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
                    button_current_expense.set_size_request(700, 100)
                    button_current_expense.add(label_current_expense)
                    button_current_expense.connect_object("event", button_press, menu)
                    hbox.pack_start(button_current_expense, False, False, 0)
                    table_current_expense.attach(hbox, j, j+1, k, k+1)
            return table_current_expense

        dt = details()
        pannable_area_details.add_with_viewport(dt)
        table_details.attach(pannable_area_details, 0, 1, 0, 1)
        win_details.add(table_details)
        menu.show_all()
        win_details.set_app_menu(menu)
        win_details.show_all()
#Here we generate each and every summarized expense as a button to be able to call the details of them with the definition above
    for t, (k, l) in enumerate(reversed(sorted(set(zip(CurrentExpenses, Item))))):
        w = "%.2f%%" % (float(k)/float(sum(CurrentExpensesAll))*100)
        if len(CurrentIncomes) == 0:
            x = "No income..."
        else:
            x = "%.2f%%" % (float(k)/float(sum(CurrentIncomes))*100)
        hbox = gtk.HBox(False, 0)
        vbox = gtk.VBox(False, 0)
        label_expenses_item = gtk.Label()
        label_expenses_item.set_text("<span size='18000'>"+str(l)+"</span>")
        label_expenses_item.set_use_markup(True)
        label_expenses_item.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))
        vbox.pack_start(label_expenses_item, True, True, 0)
        label_expenses_amount = gtk.Label()
        cur.execute("select Ft from Expenses where Month='"+previous_month+"' and Item='"+l+"';")
        rows = cur.rowcount
        PM = []
        for r in range(rows):
            rowc = cur.fetchone()
            PM.append(rowc[0])
        if sum(PM) == k: 
            amount = "Equal"
        elif sum(PM) > k:
            amount = "-%.2f%%" % (100-(float(k)/float(sum(PM))*100))
            label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
        elif  k > sum(PM):
            if sum(PM) == 0:
                amount = "No data"
                label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('grey'))
            else:
                amount = "+%.2f%%" % ((float(k)/float(sum(PM))*100)-100)
                label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))
        label_expenses_amount.set_text("<span size='18000'>"+str(amount)+"</span>")
        label_expenses_amount.set_use_markup(True)
        label_expenses_spent = gtk.Label()
        label_expenses_spent.set_text("<span size='18000'>"+str(k)+" "+Currency+"</span>")
        label_expenses_spent.set_use_markup(True)
        label_expenses_spent.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        hbox.pack_start(label_expenses_spent, True, True, 0)
        hbox.pack_start(label_expenses_amount, True, True, 0)
        vbox.pack_start(hbox, True, True, 0)
        label_expenses_by_exp = gtk.Label()
        label_expenses_by_exp.set_text("<span size='18000'>By Expense: "+str(w)+"</span>")
        label_expenses_by_exp.set_use_markup(True)
        label_expenses_by_exp.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('light blue'))
        vbox.pack_start(label_expenses_by_exp, True, True, 0)
        label_expenses_by_inc = gtk.Label()
        label_expenses_by_inc.set_text("<span size='18000'>By Income: "+str(x)+"</span>")
        label_expenses_by_inc.set_use_markup(True)
        label_expenses_by_inc.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('light blue'))
        vbox.pack_start(label_expenses_by_inc, True, True, 0)
        button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
        button.set_size_request(0, 200)
        eb = gtk.EventBox()
        button.add(vbox)
        button.connect("clicked", lambda k=k, l=l: detailed_item(k, l)) #It is crutial to define both as equal to be able to call them in the detailed expense
        eb.add(button)
        #eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#567765'))
        table.attach(eb, 0, 1, t, t+1)
    return table
#Here we define the command that deletes the certain detail and only that (it is capable to dissolve duplicated entries)
def delete_detail(k, row): 
    cur.execute("delete from Expenses where Id='"+str(row[0])+"' and Dayname='"+str(row[1])+"' and Month='"+str(row[2])+"' and Day='"+str(row[3])+"' and Year='"+str(row[4])+"' and Ft='"+str(row[5])+"' and Item='"+str(row[6])+"'and Tag='"+str(row[7])+"';")
    Items[:] = []                          #Here we clear
    CurrentItem[:] = []               #the lists' data  
    CurrentExpenses[:] = []      #to be able to
    CurrentIncomes[:] = []        #refresh
    CurrentExpensesAll[:] = []  #them
    pannable_area_refreshed = hildon.PannableArea()
    pannable_area_cmstat_refreshed = hildon.PannableArea()
    pannable_area_income_refreshed = hildon.PannableArea()
    pannable_area_refreshed.add_with_viewport(current_month())
    pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat())
    pannable_area_income_refreshed.add_with_viewport(income_details())
    table.attach(pannable_area_refreshed, 5, 10, 1, 10)
    table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
    table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
    table.show_all()
    win_details.destroy()
#Here we define the command that deletes the certain income
def delete_detail_income(j, row): 
    cur.execute("delete from Incomes where Id='"+str(row[0])+"' and Year='"+str(row[1])+"' and Month='"+str(row[2])+"' and Name='"+str(row[3])+"' and Ft='"+str(row[4])+"';")
    Items[:] = []                          #Here we clear
    CurrentItem[:] = []               #the lists' data  
    CurrentExpenses[:] = []      #to be able to
    CurrentIncomes[:] = []        #refresh
    CurrentExpensesAll[:] = []  #them
    pannable_area_refreshed = hildon.PannableArea()
    pannable_area_cmstat_refreshed = hildon.PannableArea()
    pannable_area_income_refreshed = hildon.PannableArea()
    pannable_area_refreshed.add_with_viewport(current_month())
    pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat())
    pannable_area_income_refreshed.add_with_viewport(income_details())
    table.attach(pannable_area_refreshed, 5, 10, 1, 10)
    table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
    table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
    table.show_all()
#Here we define the window to be able to add an income
def add_income(data):
    win = hildon.StackableWindow()
    win.set_title("Manage Incomes")
    table_income = gtk.Table(4, 1, True)
    menu = hildon.AppMenu()
    win.add(table_income)
    SelectedYear = ['empty']
    SelectedMonth = ['empty']
    IncomeItem = ['empty']

    date_button = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    date_button.set_label("Select Year and Month")
    month = gtk.ListStore(gobject.TYPE_STRING)
    year = gtk.ListStore(gobject.TYPE_STRING)
    selector = hildon.TouchSelector(text = True)

    for i in range(len(Year)):
        new_iter = year.append()
        year.set(new_iter, 0, Year[i])

    for i in range(len(Month)):
        new_iter = month.append()
        month.set(new_iter, 0, Month[i])

    def selection_changed(year, month):
        selected = selector.get_current_text()

        for i in range(len(Year)):
            for j in re.finditer(Year[i], selected):
                if selected[j.start():j.end()] == Year[i]:
                    SelectedYear[0] = Year[i]
                    break

        for i in range(len(Month)):
            for j in re.finditer(Month[i], selected):
                if selected[j.start():j.end()] == Month[i]:
                    SelectedMonth[0] = Month[i]
                    break

    def add_income_item(entry):
        income_item = entry.get_text()
        IncomeItem[0] = income_item
        entry.set_text("")

    def add_all_income(data):
        Items[:] = []                          #Here we clear
        CurrentItem[:] = []               #the lists' data  
        CurrentExpenses[:] = []      #to be able to
        CurrentIncomes[:] = []        #refresh
        CurrentExpensesAll[:] = []  #them
#Here are some statements to make the user to define all necesseary data
        if SelectedYear[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Date!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif SelectedMonth[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Date!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif SelectedYear[0] and SelectedMonth[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Date!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif CurrentCurrency[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Income!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif IncomeItem[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Category!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
#Here is the actual command that writes the new datas to the database
        else:
            cur.execute("insert into Incomes(Year, Month, Name, Ft) values('"+SelectedYear[0]+"', '"+SelectedMonth[0]+"', '"+IncomeItem[0]+"', '"+CurrentCurrency[0]+"');")
#Here we refresh the little statistcs on the main window
            pannable_area_refreshed = hildon.PannableArea()
            pannable_area_cmstat_refreshed = hildon.PannableArea()
            pannable_area_income_refreshed = hildon.PannableArea()
            pannable_area_refreshed.add_with_viewport(current_month())
            pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat())
            pannable_area_income_refreshed.add_with_viewport(income_details())
            table.attach(pannable_area_refreshed, 5, 10, 1, 10)
            table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
            table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
            table.show_all()
            win.destroy()

    selector.remove_column(0)
    selector.append_text_column(year, 0)
    selector.append_text_column(month, 1)
    selector.connect("changed", selection_changed)
    date_button.set_selector(selector)

    entry_ft = hildon.Entry(gtk.HILDON_SIZE_AUTO)
    entry_ft.set_text("Add Income")
    entry_ft.connect("activate", add_ft)

    entry_item = hildon.Entry(gtk.HILDON_SIZE_AUTO)
    entry_item.set_text("Add Category")
    entry_item.connect("activate", add_income_item)

    add_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    add_button.set_label("Add Income")
    add_button.connect("clicked", add_all_income)

    win.set_app_menu(menu)
    table_income.attach(date_button, 0, 1, 0, 1)
    table_income.attach(entry_ft, 0, 1, 1, 2)
    table_income.attach(entry_item, 0, 1, 2, 3)
    table_income.attach(add_button, 0, 1, 3, 4)
    win.show_all()

def income_details():
    cur.execute("select Name, Ft from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
    row_count = cur.rowcount
    table = gtk.Table (row_count, 1, False)
    table.set_row_spacings(20)
    cur.execute("select * from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")

    for j in range(row_count):
        row = cur.fetchone()
        menu = gtk.Menu()
        menu.set_size_request(90, 90)
        #label_edit = gtk.Label()
        label_delete = gtk.Label()
        #label_edit.set_text("<span size='20000'>Edit</span>")
        label_delete.set_text("<span size='20000'>\nDelete</span>")
        #label_edit.set_use_markup(True)
        label_delete.set_use_markup(True)
        #label_edit.show()
        label_delete.show()
        #menuitem_edit = gtk.MenuItem()
        menuitem_delete = gtk.MenuItem()
        #menuitem_edit.add(label_edit)
        menuitem_delete.add(label_delete)
        #menuitem_edit.show()
        menuitem_delete.show()
        #menuitem_edit.connect("activate", edit_detail)
        menuitem_delete.connect("activate", lambda j=j, row=row: delete_detail_income(j, row))
        #menu.append(menuitem_edit)
        menu.append(menuitem_delete)
        label = gtk.Label()
        label.set_text(str(row[3])+"\n\n"+str(row[4])+" "+Currency)
        label.set_justify(gtk.JUSTIFY_CENTER)
        button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
        button.add(label)
        button.connect_object("event", button_press, menu)
        table.attach(button, 0, 1, j, j+1)
    return table
#Here we define the windows to be able to add an expense
def add_expense(data):
    win = hildon.StackableWindow()
    win.set_title("Manage Expenses")
    table_expense = gtk.Table(4, 5, True)
    menu = hildon.AppMenu()
    win.add(table_expense)

    def selection_changed_item(select_item, data = None):
        item = select_item.get_current_text()
        SelectedItem[0] = item
        cur.execute("select distinct Tag from Expenses where Item='"+item+"';")
        row_count = cur.rowcount
        Tag = []
        for i in range(row_count):
            row = cur.fetchone()
            if row[0] != None:
                Tag.append(row[0])
        SortedTag = sorted(Tag)
        for j in range(len(SortedTag)):
                select_tag_selector.append_text(SortedTag[j])
        table_expense.attach(select_tag_button, 3, 4, 2, 3)
        table_expense.attach(specify_new_tag_entry, 4, 5, 2, 3)

    def selection_changed_tag(select_tag_selector, data = None):
        tag = select_tag_selector.get_current_text()
        SelectedTag[0] = tag

    def specify_new_tag(entry):
        tag = entry.get_text()
        SelectedTag[0] = tag
        entry.set_text("")

#This call is responsible for the action of adding the datas to the database
    def add_all(data):
        Items[:] = []                          #Here we clear
        CurrentItem[:] = []               #the lists' data  
        CurrentExpenses[:] = []      #to be able to
        CurrentIncomes[:] = []        #refresh
        CurrentExpensesAll[:] = []  #them
#Here are some statements to make the user to define all necesseary data
        if Date[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Date!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif CurrentCurrency[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Expense!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
        elif SelectedItem[0] == 'empty':
            note = hildon.Note("information", win, "You have to specify Item!")
            gtk.Dialog.run(note)
            gtk.Dialog.hide(note)
#Here is the actual command that writes the new datas to the database
        else:
            cur.execute("insert into Expenses(Dayname, Month, Day, Year, Ft, Item, Tag) values('"+Date[0]+"', '"+Date[1]+"', '"+Date[2]+"', '"+Date[3]+"', '"+CurrentCurrency[0]+"', '"+SelectedItem[0]+"', '"+SelectedTag[0]+"');")
#Here we refresh the little statistcs on the main window and the detailed expenses
            pannable_area_refreshed = hildon.PannableArea()
            pannable_area_cmstat_refreshed = hildon.PannableArea()
            pannable_area_income_refreshed = hildon.PannableArea()
            pannable_area_refreshed.add_with_viewport(current_month())
            pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat())
            pannable_area_income_refreshed.add_with_viewport(income_details())
            table.attach(pannable_area_refreshed, 5, 10, 1, 10)
            table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
            table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
            table.show_all()
            win.destroy()
#Below are the widgets that we use to add a new expense
    date_button = hildon.DateButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    date_selector = hildon.DateSelector()
    date_selector.connect("changed", get_date)
    date_button.set_selector(date_selector)

    entry = hildon.Entry(gtk.HILDON_SIZE_AUTO)
    entry.set_text("Add Expense")
    entry.connect("activate", add_ft)

    item_button = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
	    		    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    item_button.set_label("Choose Item")
    select_item = hildon.TouchSelector(text=True)
#Here we pull predifined items from the database and append them to the selector
    items_row = cur.execute("select * from Predefined_Items")
    if items_row >= 1:
        for i in range(items_row):
            row = cur.fetchone()
            Items.append(row[1])
        SortedItems = sorted(set(Items))
        for i in range(len(SortedItems)):
            select_item.append_text(SortedItems[i])

    select_item.connect("changed", selection_changed_item)
    item_button.set_selector(select_item)

    manage_items_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    manage_items_button.set_label("Manage Items")

    select_tag_button = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    select_tag_button.set_label("Select Tag")
    select_tag_button.show()
    select_tag_selector = hildon.TouchSelector(text = True)
    select_tag_button.set_selector(select_tag_selector)
    select_tag_selector.connect("changed", selection_changed_tag)

    specify_new_tag_entry = hildon.Entry(gtk.HILDON_SIZE_AUTO)
    specify_new_tag_entry.set_text("Add new tag")
    specify_new_tag_entry.connect("activate", specify_new_tag)
    specify_new_tag_entry.show()

    #Here we define the window where we can manage items
    def manage_items(data):
        win = hildon.StackableWindow()
        win.set_title("Manage Items")
        table = gtk.Table(3, 1, True)
        DeleteItem = []
        menu = hildon.AppMenu()
    #Here we can define the new item and add it to the dedicated database
        def additem(entry):
            item = entry.get_text()
            select_item.append_text(item)
            delete_selected_item_selector.append_text(item)
            cur.execute("insert into Predefined_Items(Name) values('"+item+"')")
            Items.append(item)
            entry.set_text("")
            win.destroy()
    #Here we can delete all items
        def delete_all_item(data):
            note = hildon.Note("confirmation", win, "Are you sure you want to delete ALL Items?")
            dialog = gtk.Dialog.run(note)
            if dialog == gtk.RESPONSE_OK:
                cur.execute("delete from Predefined_Items")
                select_item.remove_column(0)
                delete_selected_item_selector.remove_column(0)
                gtk.Dialog.hide(note)
            else:
                gtk.Dialog.hide(note)
    #Here are the widgets that we use to manage items
        entry = hildon.Entry(gtk.HILDON_SIZE_AUTO)
        entry.connect("activate", additem)
        entry.set_text("Add New Item")

        delete_selected_item_button = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
	    		    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
        delete_selected_item_button.set_title("Delete Selected Item")
    #Here we delete only selected item
        def selection_changed_delete_item(delete_selected_item_selector, data):
            item = delete_selected_item_selector.get_current_text()
            for i in range(len(Items)):
                for j in re.finditer(Items[i], item):
                    DeleteItem.append(item[j.start():j.end()])
            for i in range(len(sorted(set(DeleteItem)))):
                cur.execute("delete from Predefined_Items where Name='"+sorted(set(DeleteItem))[i]+"';")
            Items[:] = []
            refresh_list = gtk.ListStore(gobject.TYPE_STRING)    #This is crutial for refreshing the touchselector
            items_row = cur.execute("select * from Predefined_Items")
            if items_row >= 1:
                for i in range(items_row):
                    row = cur.fetchone()
                    Items.append(row[1])
                SortedItems = sorted(set(Items))
                for i in range(len(SortedItems)):
                    new_iter = refresh_list.append()        #This is crutial for 
                    refresh_list.set(new_iter, 0, SortedItems[i])     #refreshing the touchselector
            select_item.remove_column(0)                                                              #Here we 
            delete_selected_item_selector.remove_column(0)                             #refresh
            delete_selected_item_selector.append_text_column(refresh_list, 1) #the selecter
            select_item.append_text_column(refresh_list, 1)                                  #and deleter 
    
        delete_selected_item_selector = hildon.TouchSelector(text = True)
        #delete_selected_item_selector.set_column_selection_mode("multiple")
        delete_selected_item_selector.connect("changed", selection_changed_delete_item)
        delete_selected_item_button.set_selector(delete_selected_item_selector)
    #Here we append the predefined items to the touchselector
        Items[:] = []
        items_row = cur.execute("select * from Predefined_Items")
        if items_row >= 1:
            for i in range(items_row):
                row = cur.fetchone()
                Items.append(row[1])
            SortedItems = sorted(set(Items))
            for i in range(len(SortedItems)):
                delete_selected_item_selector.append_text(SortedItems[i])

        delete_all_item_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
        delete_all_item_button.set_label("Delete All Items")
        delete_all_item_button.connect("clicked", delete_all_item)

        table.attach(delete_all_item_button, 0, 1, 2, 3)
        table.attach(delete_selected_item_button, 0, 1, 1, 2)
        table.attach(entry, 0, 1, 0, 1)
        menu.show_all()
        win.set_app_menu(menu)
        win.add(table)
        win.show_all()

    manage_items_button.connect("clicked", manage_items)

    add_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			    hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    add_button.set_label("Add Expense")
    add_button.connect("clicked", add_all)

    table_expense.attach(date_button, 0, 5, 0, 1)
    table_expense.attach(entry, 0, 5, 1, 2)
    table_expense.attach(item_button, 0, 2, 2, 3)
    table_expense.attach(manage_items_button, 2, 3, 2, 3)
    table_expense.attach(add_button, 0, 5, 3, 4)
    win.set_app_menu(menu)
    win.show_all()

def add_ft(entry):
    ft = entry.get_text()
    CurrentCurrency[0] = ft
    entry.set_text("")

def goto_selected_month(data):
    month = gtk.ListStore(gobject.TYPE_STRING)
    year = gtk.ListStore(gobject.TYPE_STRING)
    SelectedYear = ['empty']
    SelectedMonth = ['empty']
    PreviousMonth = ['empty']
    selector = hildon.TouchSelector(text = True)    
    dialog = gtk.Dialog("Select year and month", None, gtk.DIALOG_NO_SEPARATOR | gtk.DIALOG_DESTROY_WITH_PARENT)
    dialog.set_size_request(0, 350)

    for i in range(len(Year)):
        new_iter = year.append()
        year.set(new_iter, 0, Year[i])

    for i in range(len(Month)):
        new_iter = month.append()
        month.set(new_iter, 0, Month[i])

    def selection_changed(year, month):
        selected = selector.get_current_text()

        for i in range(len(Year)):
            for j in re.finditer(Year[i], selected):
                if selected[j.start():j.end()] == Year[i]:
                    SelectedYear[0] = Year[i]
                    break

        for i in range(len(Month)):
            for j in re.finditer(Month[i], selected):
                if selected[j.start():j.end()] == Month[i]:
                    SelectedMonth[0] = Month[i]
                    PreviousMonth[0] = Month[i-1]
                    break

    selector.remove_column(0)
    selector.append_text_column(year, 0)
    selector.append_text_column(month, 1)
    selector.connect("changed", selection_changed)
    selector.show()
    dialog.vbox.add(selector)    #'vbox' is crutial for the dialog to display the selector
    dialog.add_button("Select", gtk.RESPONSE_OK)
    response = dialog.run()
    if response == gtk.RESPONSE_OK:
        current_month_name = SelectedMonth[0] 
        current_year = SelectedYear[0] 
        Items[:] = []                          #Here we clear
        CurrentItem[:] = []               #the lists' data  
        CurrentExpenses[:] = []      #to be able to
        CurrentIncomes[:] = []        #refresh
        CurrentExpensesAll[:] = []  #them

        def current_month_refreshed(): 
            Item = []
            currency = []
            cur.execute("select Item, Ft from Expenses where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
            row_count = cur.rowcount
            table = gtk.Table (row_count, 1, False)
            table.set_row_spacings(20)

            for i in range(1):
                for j in range(row_count):
                    row = cur.fetchone()
                    Item.append(row[0])
                    currency.append(row[1])

            cur.execute("select Ft from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
            row_count = cur.rowcount
            for j in range(row_count):
                row = cur.fetchone()
                CurrentIncomes.append(row[0])

            cur.execute("select Ft from Expenses where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
            row_count = cur.rowcount
            for j in range(row_count):
                row = cur.fetchone()
                CurrentExpensesAll.append(row[0])

            for i in range(len(Item)):
                c = []
                for j in range(len(Item)):
                    if Item[i] == Item[j]:
                        c.append(currency[j])
                CurrentExpenses.append(sum(c))

            def detailed_item(k, l):
                win_details.set_title(l)
                menu = hildon.AppMenu()
                table_details = gtk.Table(1, 1, True)
                pannable_area_details = hildon.PannableArea()

                def details():
                    cur.execute("select * from Expenses where Item = '"+l+"' and Month = '"+current_month_name+"';")
                    current_expense = cur.rowcount
                    table_current_expense = gtk.Table(current_expense, 1, False)

                    for j in range(1):
                        for k in range(current_expense):
                            row = cur.fetchone()
                            menu = gtk.Menu()
                            hbox = gtk.HBox(False, 0)
                            menu.set_size_request(90, 90)
                            lb = gtk.Label()
                            hbox.pack_start(lb, False, False, 0)
                            #label_edit = gtk.Label()
                            label_delete = gtk.Label()
                            #label_edit.set_text("<span size='20000'>Edit</span>")
                            label_delete.set_text("<span size='20000'>\nDelete</span>")
                            #label_edit.set_use_markup(True)
                            label_delete.set_use_markup(True)
                            #label_edit.show()
                            label_delete.show()
                            #menuitem_edit = gtk.MenuItem()
                            menuitem_delete = gtk.MenuItem()
                            #menuitem_edit.add(label_edit)
                            menuitem_delete.add(label_delete)
                            #menuitem_edit.show()
                            menuitem_delete.show()
                            #menuitem_edit.connect("activate", edit_detail)
                            menuitem_delete.connect("activate", lambda k=k, row=row: delete_detail(k, row))
                            #menu.append(menuitem_edit)
                            menu.append(menuitem_delete)
                            label_current_expense = gtk.Label(str(row[1])+" | "+str(row[3])+" | "+str(row[5])+" "+Currency+" | "+str(row[7]))
                            button_current_expense = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
                            button_current_expense.set_size_request(700, 100)
                            button_current_expense.add(label_current_expense)
                            button_current_expense.connect_object("event", button_press, menu)
                            hbox.pack_start(button_current_expense, False, False, 0)
                            table_current_expense.attach(hbox, j, j+1, k, k+1)
                    return table_current_expense

                dt = details()
                pannable_area_details.add_with_viewport(dt)
                table_details.attach(pannable_area_details, 0, 1, 0, 1)
                win_details.add(table_details)
                menu.show_all()
                win_details.set_app_menu(menu)
                win_details.show_all()

            for t, (k, l) in enumerate(reversed(sorted(set(zip(CurrentExpenses, Item))))):
                w = "%.2f%%" % (float(k)/float(sum(CurrentExpensesAll))*100)
                if len(CurrentIncomes) == 0:
                    x = "No income..."
                else:
                    x = "%.2f%%" % (float(k)/float(sum(CurrentIncomes))*100)
                hbox = gtk.HBox(False, 0)
                vbox = gtk.VBox(False, 0)
                label_expenses_item = gtk.Label()
                label_expenses_item.set_text("<span size='18000'>"+str(l)+"</span>")
                label_expenses_item.set_use_markup(True)
                label_expenses_item.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))
                vbox.pack_start(label_expenses_item, True, True, 0)
                label_expenses_amount = gtk.Label()
                cur.execute("select Ft from Expenses where Month='"+PreviousMonth[0]+"' and Item='"+l+"';")
                rows = cur.rowcount
                PM = []
                for r in range(rows):
                    rowc = cur.fetchone()
                    PM.append(rowc[0])
                if sum(PM) == k: 
                    amount = "Equal"
                elif sum(PM) > k:
                    amount = "-%.2f%%" % (100-(float(k)/float(sum(PM))*100))
                    label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
                elif  k > sum(PM):
                    if sum(PM) == 0:
                        amount = "No data"
                        label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('grey'))
                    else:
                        amount = "+%.2f%%" % ((float(k)/float(sum(PM))*100)-100)
                        label_expenses_amount.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))
                label_expenses_amount.set_text("<span size='18000'>"+str(amount)+"</span>")
                label_expenses_amount.set_use_markup(True)
                label_expenses_spent = gtk.Label()
                label_expenses_spent.set_text("<span size='18000'>"+str(k)+" "+Currency+"</span>")
                label_expenses_spent.set_use_markup(True)
                label_expenses_spent.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
                hbox.pack_start(label_expenses_spent, True, True, 0)
                hbox.pack_start(label_expenses_amount, True, True, 0)
                vbox.pack_start(hbox, True, True, 0)
                label_expenses_by_exp = gtk.Label()
                label_expenses_by_exp.set_text("<span size='18000'>By Expense: "+str(w)+"</span>")
                label_expenses_by_exp.set_use_markup(True)
                label_expenses_by_exp.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('light blue'))
                vbox.pack_start(label_expenses_by_exp, True, True, 0)
                label_expenses_by_inc = gtk.Label()
                label_expenses_by_inc.set_text("<span size='18000'>By Income: "+str(x)+"</span>")
                label_expenses_by_inc.set_use_markup(True)
                label_expenses_by_inc.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('light blue'))
                vbox.pack_start(label_expenses_by_inc, True, True, 0)
                button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
		        	hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
                button.set_size_request(0, 200)
                eb = gtk.EventBox()
                button.add(vbox)
                button.connect("clicked", lambda k=k, l=l: detailed_item(k, l)) #It is crutial
                                                                                                                        #to define
                                                                                                                        #both as 
                                                                                                                       #equal to be 
                                                                                                                       #able to call 
                                                                                                                       #them in the 
                                                                                                                       #detailed 
                                                                                                                       #expense
                eb.add(button)
                #eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#567765'))
                table.attach(eb, 0, 1, t, t+1)
            return table

        def income_details_refreshed():
            cur.execute("select Name, Ft from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")
            row_count = cur.rowcount
            table = gtk.Table (row_count, 1, False)
            table.set_row_spacings(20)
            cur.execute("select * from Incomes where Month = '"+current_month_name+"' and Year = '"+current_year+"';")

            for j in range(row_count):
                row = cur.fetchone()
                menu = gtk.Menu()
                menu.set_size_request(90, 90)
                #label_edit = gtk.Label()
                label_delete = gtk.Label()
                #label_edit.set_text("<span size='20000'>Edit</span>")
                label_delete.set_text("<span size='20000'>\nDelete</span>")
                #label_edit.set_use_markup(True)
                label_delete.set_use_markup(True)
                #label_edit.show()
                label_delete.show()
                #menuitem_edit = gtk.MenuItem()
                menuitem_delete = gtk.MenuItem()
                #menuitem_edit.add(label_edit)
                menuitem_delete.add(label_delete)
                #menuitem_edit.show()
                menuitem_delete.show()
                #menuitem_edit.connect("activate", edit_detail)
                menuitem_delete.connect("activate", lambda j=j, row=row: delete_detail_income(j, row))
                #menu.append(menuitem_edit)
                menu.append(menuitem_delete)
                label = gtk.Label()
                label.set_text(str(row[3])+"\n\n"+str(row[4])+" "+Currency)
                label.set_justify(gtk.JUSTIFY_CENTER)
                button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			            hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
                button.add(label)
                button.connect_object("event", button_press, menu)
                table.attach(button, 0, 1, j, j+1)
            return table

        def current_month_stat_refreshed():
            vbox = gtk.VBox(False, 0)
            label_current_month = gtk.Label()
            label_current_month.set_text("<span size='26000'>"+current_month_name+"</span>")
            label_current_month.set_use_markup(True)
            label_current_month.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))
            vbox.pack_start(label_current_month, False, False, 3)
            label_current_incomes = gtk.Label()
            label_current_incomes.set_text("<span size='17000'>Total Incomes: "+str(sum(CurrentIncomes))+" "+Currency+"</span>")
            label_current_incomes.set_use_markup(True)
            label_current_incomes.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('grey'))
            vbox.pack_start(label_current_incomes, False, False, 13)
            label_current_expenses = gtk.Label()
            label_current_expenses.set_text("<span size='17000'>Total Expenses: "+str(sum(CurrentExpensesAll))+" "+Currency+"</span>")
            label_current_expenses.set_use_markup(True)
            label_current_expenses.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
            vbox.pack_start(label_current_expenses, False, False, 5)
            if sum(CurrentIncomes) == 0:
                if sum(CurrentExpensesAll) == 0:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>No data for this month...</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
                else:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>You should get money...!!!</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
            elif sum(CurrentExpensesAll) == 0:
                if sum(CurrentIncomes) == 0:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>No data for this month...</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
                else:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>No expense in this month\nwow... hurray!!!</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
            else:
                if sum(CurrentIncomes)-sum(CurrentExpensesAll) > 0:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>Difference: "+str(sum(CurrentIncomes)-sum(CurrentExpensesAll))+" "+Currency+"</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
                elif sum(CurrentIncomes)-sum(CurrentExpensesAll) < 0:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>Difference: "+str(sum(CurrentIncomes)-sum(CurrentExpensesAll))+" "+Currency+"</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))
                elif sum(CurrentIncomes)-sum(CurrentExpensesAll) == 0:
                    label_current_difference = gtk.Label()
                    label_current_difference.set_text("<span size='17000'>You can not spend more...</span>")
                    label_current_difference.set_use_markup(True)
                    label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
            vbox.pack_start(label_current_difference, False, False, 10)
            return vbox

        pannable_area_refreshed = hildon.PannableArea()
        pannable_area_cmstat_refreshed = hildon.PannableArea()
        pannable_area_income_refreshed = hildon.PannableArea()
        pannable_area_refreshed.add_with_viewport(current_month_refreshed())
        pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat_refreshed())
        pannable_area_income_refreshed.add_with_viewport(income_details_refreshed())
        table.attach(pannable_area_refreshed, 5, 10, 1, 10)
        table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
        table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
        table.show_all()
        dialog.destroy()
#Here we define the call that an erase all data from table Expenses
def delete_all(data):
    note = hildon.Note("confirmation", win, "Are you sure you want to delete ALL data from the databases?\n\nBE CAREFUL!!! ALL DATA FROM ALL DATABASES WILL BE LOST, NOT JUST FOR CURRENT MONTH!!!")
    dialog = gtk.Dialog.run(note)
    if dialog == gtk.RESPONSE_OK:
        cur.execute("delete from Expenses")
        cur.execute("delete from Incomes")
        cur.execute("delete from Predefined_Items")
        Items[:] = []                          #Here we clear
        CurrentItem[:] = []               #the lists' data  
        CurrentExpenses[:] = []      #to be able to
        CurrentIncomes[:] = []        #refresh
        CurrentExpensesAll[:] = []   #them
        pannable_area_refreshed = hildon.PannableArea()
        pannable_area_refreshed.add_with_viewport(current_month())
        table.attach(pannable_area_refreshed, 5, 10, 1, 10)
        pannable_area_income_refreshed = hildon.PannableArea()
        pannable_area_income_refreshed.add_with_viewport(income_details())
        table.attach(pannable_area_income_refreshed, 10, 15, 1, 10)
        pannable_area_cmstat_refreshed = hildon.PannableArea()
        pannable_area_cmstat_refreshed.add_with_viewport(current_month_stat())
        table.attach(pannable_area_cmstat_refreshed, 0, 5, 0, 4)
        table.show_all()
        gtk.Dialog.hide(note)
    else:
        gtk.Dialog.hide(note)
#Here we define the call that separates the date's elements to be able to handle dayname, day, month, year separately
def get_date(date_selector, data):
    date = date_selector.get_current_text()

    for i in range(len(DayName)):
        a = date.find(DayName[i])
        if a > -1:
            Date[0] = (DayName[i])
            break

    for i in range(len(Month)):
        a = date.find(Month[i])
        if a > -1:
            Date[1] = (Month[i])
            break

    for i in re.finditer(",", date):
        for j in range(len(Day)):
            if date[i.end()-3:i.end()-1] == Day[j]:
                Date[2] = (Day[j])

    for i in re.finditer(",", date):
        for j in range(len(Year)):
            if date[i.end()+1:i.end()+5] == Year[j]:
                Date[3] = (Year[j])
#Below are the widgets of the main window
add_expense_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
add_expense_button.set_title("Add Expense")

add_income_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
add_income_button.set_title("Add Income")

delete_all_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
delete_all_button.set_title("Delete ALL")

goto_month_button = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
goto_month_button.set_title("Go to selected month")

add_expense_button.connect("clicked", add_expense)
add_income_button.connect("clicked", add_income)
delete_all_button.connect("clicked", delete_all)
goto_month_button.connect("clicked", goto_selected_month)

#menu.append(delete_all_button) #This button enables you to delete all data from
                                                            #the database. Be careful enabling it. It will show
                                                            #up in the main window's appmenu and asks 
                                                            #whether you really want to delete all data
menu.append(goto_month_button)

pannable_area = hildon.PannableArea()
current = current_month()
pannable_area.add_with_viewport(current)
#Here we make the little statistics of the current month on the main window
def current_month_stat():
    vbox = gtk.VBox(False, 0)
    label_current_month = gtk.Label()
    label_current_month.set_text("<span size='26000'>"+current_month_name+"</span>")
    label_current_month.set_use_markup(True)
    label_current_month.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))
    vbox.pack_start(label_current_month, False, False, 3)
    label_current_incomes = gtk.Label()
    label_current_incomes.set_text("<span size='17000'>Total Incomes: "+str(sum(CurrentIncomes))+" "+Currency+"</span>")
    label_current_incomes.set_use_markup(True)
    label_current_incomes.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('grey'))
    vbox.pack_start(label_current_incomes, False, False, 13)
    label_current_expenses = gtk.Label()
    label_current_expenses.set_text("<span size='17000'>Total Expenses: "+str(sum(CurrentExpensesAll))+" "+Currency+"</span>")
    label_current_expenses.set_use_markup(True)
    label_current_expenses.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
    vbox.pack_start(label_current_expenses, False, False, 5)
    if sum(CurrentIncomes) == 0:
        if sum(CurrentExpensesAll) == 0:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>No data for this month...</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
        else:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>You should get money...!!!</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
    elif sum(CurrentExpensesAll) == 0:
        if sum(CurrentIncomes) == 0:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>No data for this month...</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
        else:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>No expense in this month\nwow... hurray!!!</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
    else:
        if sum(CurrentIncomes)-sum(CurrentExpensesAll) > 0:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>Difference: "+str(sum(CurrentIncomes)-sum(CurrentExpensesAll))+" "+Currency+"</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
        elif sum(CurrentIncomes)-sum(CurrentExpensesAll) < 0:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>Difference: "+str(sum(CurrentIncomes)-sum(CurrentExpensesAll))+" "+Currency+"</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))
        elif sum(CurrentIncomes)-sum(CurrentExpensesAll) == 0:
            label_current_difference = gtk.Label()
            label_current_difference.set_text("<span size='17000'>You can not spend more...</span>")
            label_current_difference.set_use_markup(True)
            label_current_difference.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('yellow'))
    vbox.pack_start(label_current_difference, False, False, 10)
    return vbox

pannable_area_cmstat = hildon.PannableArea()
cmstat = current_month_stat()
pannable_area_cmstat.add_with_viewport(cmstat)

pannable_area_incomes = hildon.PannableArea()
pannable_area_incomes.add_with_viewport(income_details())

label_detailed_items = gtk.Label()
label_detailed_items.set_text("<span size='26000'>Expenses</span>")
label_detailed_items.set_use_markup(True)
label_detailed_items.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))
label_detailed_incomes = gtk.Label()
label_detailed_incomes.set_text("<span size='26000'>Incomes</span>")
label_detailed_incomes.set_use_markup(True)
label_detailed_incomes.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#f47500'))

table.attach(add_expense_button, 0, 5, 4, 7)
table.attach(add_income_button, 0, 5, 7, 10)
table.attach(pannable_area_cmstat, 0, 5, 0, 4)
table.attach(label_detailed_items, 5, 10, 0, 1)
table.attach(pannable_area, 5, 10, 1, 10)
table.attach(label_detailed_incomes, 10, 15, 0, 1)
table.attach(pannable_area_incomes, 10, 15, 1, 10)

menu.show_all()
#def app_quit(widget, data=None):
#    gtk.main_quit()

#win.connect("destroy", app_quit)
win.set_app_menu(menu)
win.connect("destroy", lambda x: gtk.main_quit())
win.show_all()
gtk.main()

if __name__ == "__main__":
    main()
